﻿using System;
using System.Threading.Tasks;
using System.Windows;
using System.IO;
using System.Windows.Forms;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Parsing;

namespace ConsoleApplication1
{
    class Program
    {
        [STAThread]
        static void Main(string[] args)
        {

            // Keep display open file dialog if the prior result was OK
            for (OpenFileDialog fileDialog = new OpenFileDialog();
                    fileDialog.ShowDialog() == DialogResult.OK ;)
            {
                Stream stream = fileDialog.OpenFile();
                MemoryStream pdfStream = new MemoryStream();
                stream.CopyTo(pdfStream);
                var mergedPdf = new PdfDocument();
                PdfDocumentBase.Merge(mergedPdf, new object[] { pdfStream.ToArray() });

                //Method 1 - using streams
                try
                {
                    var mergedPdfStream = new MemoryStream();
                    mergedPdf.Save(fileDialog.FileName + ".m.pdf");
                    MessageBox.Show("PDF merging using stream succeeded.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("PDF merging using stream FAILED.\r\n" + ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

                //Method 2 - using pages
                try
                {
                    var pdm = new PdfDocument();
                    var pd = new PdfLoadedDocument(fileDialog.FileName);
                    pdm.Append(pd);
                    pdm.Save(fileDialog.FileName + ".pm.pdf");
                    MessageBox.Show("PDF merging using pages succeeded.", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("PDF merging using pages FAILED.\r\n" + ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }
    }
}
